/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.batch.tutorial.uc0001.jb0002;

import java.util.Date;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import jp.terasoluna.batch.tutorial.uc0001.JB0002Data;
import jp.terasoluna.batch.tutorial.uc0001.JB0002JobContext;
import jp.terasoluna.fw.batch.messages.MessageAccessor;
import jp.terasoluna.fw.batch.openapi.BLogic;
import jp.terasoluna.fw.batch.openapi.BLogicResult;
import jp.terasoluna.fw.batch.openapi.ReturnCode;
import jp.terasoluna.fw.file.dao.FileLineWriter;

/**
 * ビジネスロジッククラス。
 */
public class FileBLogic implements BLogic<JB0002Data, JB0002JobContext> {


    /**
     * ログクラス。
     */
    private static final Log log = LogFactory.getLog(FileBLogic.class);
    
    /**
     * メッセージ取得クラス。
     * Springによりインスタンス生成され設定される。
     */
    private MessageAccessor messageAccessor = null;
 
  
    /**
     * ファイル出力用行ライタクラス。
     * Springによりインスタンス生成され設定される。
     */
    private FileLineWriter<JB0002Data> fileLineWriter = null;
    
    /**
     * ビジネスロジックを実行する。
     * @param nyukinData 入力パラメータ
     * @param jobContext ジョブコンテキスト
     */
    public BLogicResult execute(JB0002Data nyukinData, JB0002JobContext jobContext) {

        //取引日と運用日付の比較
        Date torihikibi = nyukinData.getTorihikibi();
        Date unyohiduke = jobContext.getUnyohiduke();
    
        if (!torihikibi.before(unyohiduke)) {
            
            //取引日 >= 運用日付 ならばメッセージを取得しログに出力する。
            String[] args = {nyukinData.getKokyakuid() };
            String message = messageAccessor.getMessage("msg.SampleMsg", args);
            
            log.warn(message);
        }
    
    
        //入金金額が10,000以上のデータをファイルに出力
        int nyukin = nyukinData.getNyukin();
        if (nyukin >= 10000) {
            //ファイルへ書き込み
            fileLineWriter.printDataLine(nyukinData);
        
            //処理件数をカウントアップ
            jobContext.incrementCount();
        }
        
        //ビジネスロジック処理結果オブジェクトを返却する
        BLogicResult result = new BLogicResult(ReturnCode.NORMAL_CONTINUE);
        return result;
    }
    
    /**
     * メッセージ取得クラスを設定する。
     * @param msgAcc メッセージ取得クラス
     */
    public void setMessageAccessor(MessageAccessor msgAcc) {
        this.messageAccessor = msgAcc;
    }
    
    /**
     * ファイル出力用行ライタクラスを設定する。
     * @param fileLineWriter ファイル出力用行ライタクラス
     */
    public void setFileLineWriter(FileLineWriter<JB0002Data> fileLineWriter){
        this.fileLineWriter = fileLineWriter;
    }
}
